///Класс Сущности от которого наследуются остальные
class Artifact{
    constructor(side,x,y,width,height,ui,state){
        let that = this;
        this.ui = ui;
        this.side = side;
        this.state = state;
        this.id = null;
        this.typeId = null;
        this.name = 'name';
        this.isUsable = true;
        this.description = 'description';
        this.width = width;
        this.height = height;
        this.imageKey = 'place';
        this.isOnCard = false;
        this.card = null;
        this.sprite = this.ui.addImageWithDraggableBorder(7,false,x,y,this.width,this.height,this.imageKey,1,0xFFD700);
        this.x = this.sprite.x;
        this.y = this.sprite.y;
        
        
        
        this.sprite.input.enableDrag();

        this.sprite.events.onDragStart.add(function(){
            that.ui.changeLayer(8,this.sprite.BORDER);
            that.ui.changeLayer(8,this.sprite);
        }, this);
        
        this.sprite.events.onDragStop.add(function(){
            that.ui.changeLayer(7,this.sprite.BORDER);
            that.ui.changeLayer(7,this.sprite);
            ///Проверяем где остановились
            let card = that.getCollisionCard();
            if(card){
                ///Если Положили на карту и на карте неn арта, и ставка в этом ходу еще не сделана
                if( (card.artifactId == null) && (!that.state.isTurnBet()) ){
                    card.artifactId = that.id;
                    ///Запрещаем двигать
                    //that.sprite.input.draggable = false;
                    ///console.log(card)
                    /*
                    that.sprite.x = card.cardSprite.x;
                    that.sprite.y = card.cardSprite.y + 43;
                    */
                    //card.placeArtifact(that);
                    ///Отправляем ставку
                    HANDLER.betArtifact(that.id,card.id);
                    that.state.makeBet();
                     ///Возвращаем на место
                    that.sprite.x = that.x;
                    that.sprite.y = that.y;
                    card.showCardChoise();
                    that.showArtLight();
                    
                   
                }else{
                    ///Возвращаем на место
                    that.sprite.x = that.x;
                    that.sprite.y = that.y;
                }
            }else{
                ///Возвращаем на место
                that.sprite.x = that.x;
                that.sprite.y = that.y;
            }
           
        }, this);   
        
        let lastCard = null;
        ///Обноврение перетаскивания
        this.sprite.events.onDragUpdate.add(function(pointer){
            let card = that.getCollisionCard();
            if(card !== lastCard){
                ///Если навели на карту
                if(card){
                    card.onArtifactOver();
                }
                if(lastCard){
                    lastCard.onArtifactOut();
                }
                lastCard = card;
            }
            
        }, this);
        this.images = [];
        ///Эффект льда
        this.images['iceEffect'] = this.ui.addImage(5,false,this.sprite.x,this.sprite.y,this.sprite.width,this.sprite.height,'ice',0.7,false);
        this.images['iceEffect'].animations.add('freeze');
        this.images['iceEffect'].visible = false;
        
        this.images['artLight'] = this.ui.addImage(7,false,this.sprite.x,this.sprite.y,110,110,'art_light',1,false);
        this.images['artLight'].visible = false;
        
        
        
        this.sounds = [];
        this.sounds['freeze'] = this.ui.addSound('freeze',false,0.6);
        this.sounds['onbet'] = this.ui.addSound('onbet',false,0.6);
        
        this.ui.addUpdate(function(){
            for(let i in that.images){
                that.images[i].x = that.sprite.x;
                that.images[i].y = that.sprite.y;
            }
        });
        ////
        ///Если противник
        let front = 'top';
        let frontBack = 'right';
        if(side == 'enemy'){
            this.sprite.input.draggable = false;
            front = 'bot';
            frontBack = 'right';
        }
        /*
        this.ui.addTitleTextWithImages(400,frontBack,front,'center',ASSETS.wordStyles,ASSETS.textStyles['title'],this.sprite,function(){
            return KEEPER.getArtifactTextInfo(that.typeId);
        });
        */
        let tile = state.addTitleForArtifacts(ui,this.sprite,function(){
            return that.typeId;
        });
        //addDynamycTitleWithColors(layer,textWidth,obj,rightleft,topbot,style,wordTypes,getTextFunction)
        //this.ui.addDynamycTitle(3,200,this.sprite,frontBack,front,ASSETS.textStyles['title'],function(){
        /*
        this.ui.addDynamycTitleWithColors(5,200,this.sprite,frontBack,front,ASSETS.textStyles['title'],ASSETS.wordStyles,function(){
            return KEEPER.getArtifactTextInfo(that.typeId);
        });
        let tile = 
        */
        
    }
    update(artifact){
        if(artifact){
            
            this.id = artifact.id;
            this.typeId = artifact.artifactTypeId;
            if((this.isUsable !== artifact.artifactIsUsable)&&(this.isOnCard)){
                this.isUsable = artifact.artifactIsUsable;
                this.onUsebleChange();
            }
            
            this.artifactInfo = ATLAS.getArtifactInfoById(this.typeId);
            this.name = this.artifactInfo.name;
            this.description = this.artifactInfo.description;
            this.imageKey = this.artifactInfo.imageKey;
            this.sprite.loadTexture(this.imageKey);
            this.sprite.width = this.width;
            this.sprite.height = this.height;
            if(this.state.turnBetMaked == false){
                this.setArtifactOnCard();
            }
            //this.updateUsable();
        }
        if(this.state.isEnd)
            this.onBattleEnd(); 
      
        if((this.state.canDragArtifacts)&&(!(this.side == 'enemy'))&&(!this.isOnCard)){
            this.sprite.input.draggable = true;   
        }else{
            this.sprite.input.draggable = false;
        }
        
        if(!this.state.turnBetMaked){
            this.images['artLight'].visible = false;
        }
            
            
    }
    onBattleEnd(){
        this.sprite.input.draggable = false;
    }
    onPlaseOnCard(){
        this.sounds['onbet'].play();
        this.ui.changeLayer(3,this.sprite.BORDER);
        this.ui.changeLayer(3,this.sprite);
    }
    onUsebleChange(){
        if(!this.isUsable){
            this.images['iceEffect'].visible = true;
            this.images['iceEffect'].animations.play('freeze', 5, false);
            this.sounds['freeze'].play();
        }else{
            this.iceEffect.visible = false;
        }
    }
    showArtLight(){
        this.images['artLight'].visible = true;
    }
    /*
    updateUsable(){
       if(!this.isUsable){
            this.iceEffect.animations.play('ice', 10, true);
            this.sprite.tint = 0x800000;
            //this.sprite.tint = 0x696969;
        }else{
            this.sprite.tint = 0xFFFFFF;
        } 
    }
    */
    clearAllAnimations(){
        this.sprite.BORDER.destroy();
        for(let i in this.images){
            this.images[i].visible = false;
        }
    }
    isArtifactOnCard(){
        ////Проверяем лежит ли фишка на существе, если да то сверяем координаты,
        if(this.card) 
            return true;
        else return false;
    }
    setArtifactOnCard(){
        ////Проверяем лежит ли фишка на существе, если да то сверяем координаты,
        let card = null;
        switch(this.side){
            case 'our': 
                card = this.getOurCardById(this.id);
                break;
            case 'enemy': 
                card = this.getEnemyCardById(this.id);
                break;
        }
        ///Если карта сменилась (или появилась переставляем фишку на карту)
        if(this.card != card){
            this.card = card;
            ///Если карта есть значит фишка лежит на крте
            if(card){
                card.placeArtifact(this);
                ////Сверяем координаты фишки и карты если не одинаковые поправляем
                
                //if((this.x !== card.x) || (this.y !== card.y+ 43)){
                //    if(this.side == 'enemy'){
                        ///Анимация ппередвижения фишки
                 //       let tween = game.add.tween(this.sprite).to( { x: card.x,y: card.y + 43}, 1000, Phaser.Easing.Linear.None, true);
                 //       tween.onComplete.add(function(){
               //             that.x = that.sprite.x;
               //             that.y = that.sprite.x;
                //        }, this);
                        
                //    }else{
                        /*
                        this.x = card.x;
                        this.y = card.y + 43;
                        */
                 //       card.placeArtifact(this);
                        /*
                        this.sprite.x = card.x;
                        this.sprite.y = card.y+ 43;
                        */
                  //  }




               // }

            }
        }
        
    }
    move(newX,newY,time,onEnd){
        this.x = newX;
        this.y = newY;
        let tween = game.add.tween(this.sprite).to( { x: this.x,y: this.y}, time, Phaser.Easing.Linear.None, true);
        tween.onComplete.add(onEnd, this);
        
    }
    getEnemyCardById(artifactId){
        for(let i in this.state.enemyCards){
           if(this.state.enemyCards[i].artifactId == artifactId)
               return this.state.enemyCards[i];
       } 
        return false;
    }
    getOurCardById(artifactId){
        for(let i in this.state.ourCards){
           if(this.state.ourCards[i].artifactId == artifactId)
               return this.state.ourCards[i];
        } 
        return false;
    }
    getCollisionCard(){
        for(let i in this.state.ourCards){
            if(KEEPER.checkCollision(this.sprite,this.state.ourCards[i])){
                    ///Есть столкновение
                return this.state.ourCards[i];
            }
                   
        }
        return false;
    }
    getRandomInt(min, max){

      return Math.floor(Math.random() * (max - min + 1)) + min;

    }
    
}